unit hiListBoxEx; { ListBoxEx ver 4.50}

interface

{$I share.inc}

uses WIndows,Kol,Share,WinList,Messages;

const
   NONE     = 0;
   SCALE    = 1;
   MOSAIC   = 2;
   GRADIENT = 3;

type
  THIListBoxEx = class(THIWinList)
   private
     fCutText:boolean;
     fGradient:boolean;
     fGutter:boolean;
     fFrame:boolean;     
     fBumpText:boolean;
     fDepthGradient:integer;
     fDepthGutter:integer;
     fDepthBack:integer;
     fDarkColor:TColor;
     fLightColor:TColor;
     fDarkClrGutt:TColor;
     fLightClrGutt:TColor;
     fDarkClrBack:TColor;
     fLightClrBack:TColor;
     fHorizontal:boolean;
     fColorFrame:TColor;
     fScaleImage:byte;
     fInversGrad:boolean;
     fInversGutt:boolean;
     fInversBack:boolean;
     fInversClrTxt:boolean;
     fIndentImg:integer;
     fImgSize:byte;
     fBackgroundImg:HBITMAP;
     fStrings:string;
     fMultiSelect:boolean;
     fBmpTransparent:TColor;
     fIconToBmp:boolean;
     fTransparent:boolean;

     Arr,ValArr:PArray;
     Icon:PIcon;
     bmp:PBitmap;
     IList:PImageList;
     ICArray:PArray;
     ImageSize:integer;
     BackgroundImg:HBITMAP;
     procedure Select(idx:integer); override;
     procedure InitBackgroundImg();
     procedure _OnResize( Sender: PObj ); override;
     function  _OnMeasureItem( Sender: PObj; Idx: Integer ):Integer;
     function  _OnDrawItem( Sender: PObj; DC: HDC; const Rect: TRect; ItemIdx: Integer;
                            DrawAction: TDrawAction; ItemState: TDrawState ): Boolean;
     procedure _arr_set(var Item:TData; var Val:TData);
     function  _arr_get(Var Item:TData; var Val:TData):boolean;
     function  _arr_count:integer;
     procedure _val_arr_set(var Item:TData; var Val:TData);
     function  _val_arr_get(Var Item:TData; var Val:TData):boolean;
     function  _val_arr_count:integer;
     procedure SetIListProp(Color:TColor);
     procedure SetIcons(const value:PStrListEx);
     procedure SetIndex(const value:PStrListEx);
     procedure _SetIcon(var Item:TData; var Val:TData);
     function _GetIcon(Var Item:TData; var Val:TData):boolean;
     procedure _AddIcon(var Val:TData);
     function  _CountIcon:integer;
   public

     _prop_Sort:boolean;
     _prop_Extended:boolean;
     _prop_IdxIcons:PStrListEx;
     _prop_Icons:PStrListEx;
     
     property _prop_Strings:string        write fStrings;
     property _prop_MultiSelect:boolean   write fMultiSelect;
     property _prop_BmpTransparent:TColor write fBmpTransparent;
     property _prop_IconToBmp:boolean     write fIconToBmp;
     property _prop_BackgroundImg:HBITMAP write fBackgroundImg;
     property _prop_ImgSize:byte          write fImgSize;
     property _prop_CutText:boolean       write fCutText;
     property _prop_Gradient:boolean      write fGradient;
     property _prop_Gutter:boolean        write fGutter;
     property _prop_Frame:boolean         write fFrame;     
     property _prop_BumpText:boolean      write fBumpText;
     property _prop_DepthGradient:integer write fDepthGradient;
     property _prop_DepthGutter:integer   write fDepthGutter;
     property _prop_DepthBack:integer     write fDepthBack;
     property _prop_DarkColor:TColor      write fDarkColor;
     property _prop_LightColor:TColor     write fLightColor;
     property _prop_DarkClrGutt:TColor    write fDarkClrGutt;
     property _prop_LightClrGutt:TColor   write fLightClrGutt;
     property _prop_DarkClrBack:TColor    write fDarkClrBack;
     property _prop_LightClrBack:TColor   write fLightClrBack;
     property _prop_Horizontal:boolean    write fHorizontal;
     property _prop_ColorFrame:TColor     write fColorFrame;
     property _prop_ScaleImage:byte       write fScaleImage;
     property _prop_InversGrad:boolean    write fInversGrad;
     property _prop_InversGutt:boolean    write fInversGutt;
     property _prop_InversBack:boolean    write fInversBack;
     property _prop_InversClrTxt:boolean  write fInversClrTxt;
     property _prop_IndentImg:integer     write fIndentImg;

     procedure Init; override;
     destructor Destroy; override;
     procedure _work_doGradient(var _Data:TData; Index:word);
     procedure _work_doGutter(var _Data:TData; Index:word);
     procedure _work_doFrame(var _Data:TData; Index:word);
     procedure _work_doDarkColor(var _Data:TData; Index:word);
     procedure _work_doLightColor(var _Data:TData; Index:word);
     procedure _work_doDarkClrGutt(var _Data:TData; Index:word);
     procedure _work_doLightClrGutt(var _Data:TData; Index:word);
     procedure _work_doDarkClrBack(var _Data:TData; Index:word);
     procedure _work_doLightClrBack(var _Data:TData; Index:word);
     procedure _work_doHorizontal(var _Data:TData; Index:word);
     procedure _work_doColorFrame(var _Data:TData; Index:word);
     procedure _work_doBumpText(var _Data:TData; Index:word);
     procedure _work_doBackgroundImg(var _Data:TData; Index:word);
     procedure _work_doScaleImage(var _Data:TData; Index:word);
     procedure _work_doInversClrTxt(var _Data:TData; Index:word);
     procedure _work_doInversGrad(var _Data:TData; Index:word);
     procedure _work_doInversGutt(var _Data:TData; Index:word);
     procedure _work_doInversBack(var _Data:TData; Index:word);
     procedure _work_doCutText(var _Data:TData; Index:word);
     procedure _work_doDepthGradient(var _Data:TData; Index:word);
     procedure _work_doDepthGutter(var _Data:TData; Index:word);
     procedure _work_doDepthBack(var _Data:TData; Index:word);
     procedure _work_doSelectAll(var _Data:TData; Index:word);
     procedure _work_doEnsureVisible(var _Data:TData; Index:word);
     procedure _var_Index(var _Data:TData; Index:word);
     procedure _var_SelectArray(var _Data:TData; Index:word);
     procedure _var_ValueArray(var _Data:TData; Index:word);
     procedure _var_IconArray(var _Data:TData; Index:word);
  end;

function MakeArrayIcon(Names:PChar; Values:array of integer):PStrListEx;

implementation

function MakeArrayIcon;begin Result:= MakeArrayInteger(Names,Values);end;

//-----------------------       ----------------------

type

  AGRBQuad = array [0..0] of RGBQuad;
  PAGRBQuad = ^AGRBQuad;

  PPoints = ^TPoints;
  TPoints = array[0..0] of TPoint;

  PColor = ^TColor;

function GetLightColor(Color: TColor; Light: Byte) : TColor;
var   fFrom: TRGB;
begin
  PColor(@fFrom)^:= Color2RGB(Color);
  Result := RGB(
    (FFrom.R*100 + (255 - FFrom.R) * Light) div 100,
    (FFrom.G*100 + (255 - FFrom.G) * Light) div 100,
    (FFrom.B*100 + (255 - FFrom.B) * Light) div 100
  );
end;

function GetShadeColor(Color: TColor; Shade: Byte) : TColor;
var   fFrom: TRGB;
begin
  PColor(@fFrom)^:= Color2RGB(Color);
  Result := RGB(
    Max(0, FFrom.R - Shade),
    Max(0, FFrom.G - Shade),
    Max(0, FFrom.B - Shade)
  );
end;

//******************************  **************************************
  
type
  COLOR16 = $0000..$FF00;
  TTriVertex = packed record
    x, y: DWORD;
    Red, Green, Blue, Alpha: COLOR16;
  end;
function GradientFill(DC: HDC; Vertex: Pointer; NumVertex: Cardinal;
                      Mesh: Pointer; NumMesh, Mode: DWORD): BOOL; stdcall;
                      external 'msimg32.dll' name 'GradientFill';

procedure _Gradient(Sender:PControl; DC:HDC; cbRect:TRect; Gradient:boolean; DepthGradient:integer;
                    StartColor,EndColor,ColorFrame:TColor; Frame,Horizontal,InversGrad:boolean);
var   hdcMem:HDC;
      hdcBmp:HBITMAP;
      hWidth,hHeight:integer;
      vert: array[0..1] of TTriVertex;
      gRect: TGradientRect;
begin
   with Sender{$ifndef F_P}^{$endif} do begin
      hWidth:= cbRect.Right - cbRect.Left;
      hHeight:= cbRect.Bottom - cbRect.Top;
      hdcMem:= CreateCompatibleDC(0);
      hdcBmp:= CreateCompatibleBitmap(DC,hWidth,hHeight);
      SelectObject(hdcMem, hdcBmp);

      StartColor := Color2RGB(StartColor);
      EndColor := Color2RGB(EndColor); 

      if Gradient then
         StartColor:= GetLightColor(StartColor, max(0,min(100,DepthGradient)))
      else
         EndColor := StartColor; 
       
      if Frame then begin
         vert[0].x      := 1;
         vert[0].y      := 1;
         vert[1].x      := hWidth-1;
         vert[1].y      := hHeight-1;
         Canvas.Brush.Color:= Color2RGB(ColorFrame);
         FillRect(hdcMem,MakeRect(0,0,hWidth,hHeight),Canvas.Brush.Handle);
      end else begin
         vert[0].x      := 0;
         vert[0].y      := 0;
         vert[1].x      := hWidth;
         vert[1].y      := hHeight;
      end;
      vert[0].Alpha  := $ff00; // ???
      vert[1].Alpha  := vert[0].Alpha;  

      if not InversGrad then begin
         vert[0].Red    := GetRValue(StartColor) shl 8;
         vert[0].Green  := GetGValue(StartColor) shl 8;
         vert[0].Blue   := GetBValue(StartColor) shl 8;
         vert[1].Red    := GetRValue(EndColor) shl 8;
         vert[1].Green  := GetGValue(EndColor) shl 8;
         vert[1].Blue   := GetBValue(EndColor) shl 8;
      end else begin
         vert[1].Red    := GetRValue(StartColor) shl 8;
         vert[1].Green  := GetGValue(StartColor) shl 8;
         vert[1].Blue   := GetBValue(StartColor) shl 8;
         vert[0].Red    := GetRValue(EndColor) shl 8;
         vert[0].Green  := GetGValue(EndColor) shl 8;
         vert[0].Blue   := GetBValue(EndColor) shl 8;
      end;

      gRect.UpperLeft  := 0;
      gRect.LowerRight := 1;

      if Horizontal then
         GradientFill(hdcMem, @vert, 2, @gRect, 1, GRADIENT_FILL_RECT_H)
      else
         GradientFill(hdcMem, @vert, 2, @gRect, 1, GRADIENT_FILL_RECT_V);
      BitBlt(DC, cbRect.Left, cbRect.Top, hWidth, hHeight, hdcMem, 0, 0, SRCCOPY);
      DeleteDC(hdcMem);
      DeleteObject(hdcBmp);
   end;
end;

//******************************************************************************

function ScaleImage(Sender:PControl; bitmap:HBITMAP; ImgSize:integer; mode:byte):HBITMAP;
var   nbmp,bmp,bmprect:PBitmap;
      sh,sw,nh,nw,iw,ih,i,j:integer;
begin

with Sender{$ifndef F_P}^{$endif} do begin
   Result:= 0;
   ih:= max(ImgSize, Sender.Canvas.TextExtent('W').cy);
   case mode of
      NONE: exit;
      GRADIENT: exit;
      SCALE: begin
         nbmp:= NewDIBBitmap(1,1,pf32bit);
         nbmp.handle:= CopyImage(bitmap,IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION);
      end;
      MOSAIC: begin
         bmprect:= NewDIBBitmap(1,1,pf32bit);
         bmprect.handle:= CopyImage(bitmap,IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION);
         nh:= Height div ih;
         if Height mod ih <> 0 then nh:= nh + 1;
         sh:= nh*ih;
         nh:= sh div bmprect.height;
         if sh mod bmprect.height <> 0 then nh:= nh + 1;
         sh:= nh*bmprect.height;
         nw:= ((Width*sh*100 div Height) div bmprect.width) div 100;
         if (((Width*sh*100 div Height) mod bmprect.width) <> 0) or (nw = 0) then nw:= nw + 1;
         sw:= nw*bmprect.width;
         nbmp:= NewDIBBitmap(sw,sh,pf32bit);
         j:= 0;
         repeat
            i:= 0;
            repeat
               BitBlt(nbmp.Canvas.Handle,i*bmprect.Width,j*bmprect.height,
                      bmprect.width,bmprect.height,bmprect.canvas.handle,0,0,SRCCOPY);
               inc(i);
            until i = nw;
            inc(j);
         until j = nh;
         bmprect.free;
      end
      else nbmp:= NewDIBBitmap(1,1,pf32bit);
   end;   
   nh:= Height div ih;
   if Height mod ih <> 0 then nh:= nh + 1;
   sh:= nh*ih;
   sw:= (nbmp.width*sh*100 div nbmp.height) div 100;
   bmp:= NewDIBBitmap(Width,sh,pf32bit);
   SetStretchBltMode(bmp.canvas.handle, HALFTONE);
   bmp.canvas.Brush.Color := Color2RGB(Color);
   FillRect(bmp.canvas.handle,bmp.BoundsRect,bmp.canvas.Brush.Handle);
   iw:= (nbmp.height*100 div sh)*abs(sw-Width) div 200;
   if sw > Width then
      StretchBlt(bmp.canvas.handle,0,0,Width,sh,
                 nbmp.canvas.handle,iw,0,nbmp.width - iw*2,nbmp.height,SRCCOPY)      
   else
      StretchBlt(bmp.canvas.handle,0,0,sw,sh,
                 nbmp.canvas.handle,0,0,nbmp.width,nbmp.height,SRCCOPY);
   Result:= CopyImage(bmp.handle,IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION);
   bmp.free;
   nbmp.free;
end;
end;

//---------------------------------------------------------------------

procedure THIListBoxEx._work_doGradient;begin      fGradient:= ReadBool(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doGutter;begin        fGutter:= ReadBool(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doInversClrTxt;begin  fInversClrTxt:= ReadBool(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doInversGrad;begin    fInversGrad:= ReadBool(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doInversGutt;begin    fInversGutt:= ReadBool(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doInversBack;begin    fInversBack:= ReadBool(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doFrame;begin         fFrame:= ReadBool(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doDarkColor;begin     fDarkColor:= ToInteger(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doLightColor;begin    fLightColor:= ToInteger(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doDarkClrGutt;begin   fDarkClrGutt:= ToInteger(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doLightClrGutt;begin  fLightClrGutt:= ToInteger(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doDarkClrBack;begin   fDarkClrBack:= ToInteger(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doLightClrBack;begin  fLightClrBack:= ToInteger(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doHorizontal;begin    fHorizontal:= ReadBool(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doColorFrame;begin    fColorFrame:= ToInteger(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doBumpText;begin      fBumpText:= ReadBool(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doCutText;begin       fCutText:= ReadBool(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doDepthGradient;begin fDepthGradient:= ToInteger(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doDepthBack;begin     fDepthBack:= ToInteger(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doDepthGutter;begin   fDepthGutter:= ToInteger(_Data);Control.Invalidate;end;
procedure THIListBoxEx._work_doBackgroundImg;
begin
   if not _IsBitmap(_Data) then exit;
   fBackgroundImg:= CopyImage(ToBitmap(_Data).handle,IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION);
   InitBackgroundImg;
end;
procedure THIListBoxEx._work_doScaleImage;
begin
   fScaleImage:= ToIntIndex(_Data);
   InitBackgroundImg;
end;

procedure THIListBoxEx.InitBackgroundImg;
begin
   if (fBackgroundImg = 0) then exit;
   DeleteObject(BackgroundImg);
   BackgroundImg:= ScaleImage(Control, fBackgroundImg, fImgSize + fIndentImg*2, fScaleImage);   
   Control.Invalidate;
end;

//------------------------       ----------------------

procedure THIListBoxEx.Init;
var   Flags:TListOptions;
begin
   Flags:= [loNoIntegralHeight,loNoExtendSel];
   fTransparent := _prop_Transparent;
   if _prop_Sort then include(Flags,loSort);
   if _prop_Extended then include(Flags,loOwnerDrawFixed);
   if fMultiSelect then include(Flags,loMultiSelect);
   ImageSize:= max(fImgSize + fIndentImg*2,fImgSize);
   Control:= NewListBox(FParent,Flags);
   Control.OnSelChange := _OnClick;
   Control.OnMeasureItem:= _OnMeasureItem;
   Control.OnDrawItem:= _OnDrawItem;
inherited;

   SetStrings(fStrings);
   Control.Perform(LB_SETHORIZONTALEXTENT, 200, 0);
   if _prop_Extended then begin 
      IList:= NewImageList(nil);
      InitBackgroundImg;
      if Assigned(_prop_Icons) then SetIcons(_prop_Icons);
      if Assigned(_prop_IdxIcons) then SetIndex(_prop_IdxIcons);
      _OnResize(Control);
   end;
end;

destructor THIListBoxEx.Destroy;
begin
   if Assigned(IList) then IList.free;
   If Assigned(Icon) then Icon.free;
   If Assigned(bmp) then bmp.free;
   if ICArray <> nil then Dispose(ICArray);
   if Arr <> nil then Dispose(Arr);
   if ValArr <> nil then Dispose(ValArr);
   DeleteObject(BackgroundImg);
   inherited Destroy;
end;

procedure THIListBoxEx.SetIListProp;
begin
   IList.BkColor:= Color;
   IList.Colors:= ilcColor32;
   IList.ImgWidth:= fImgSize;
   IList.ImgHeight:= fImgSize;
end;

procedure THIListBoxEx.SetIcons;
var i:integer;
begin
   if fImgsize = 0 then fImgsize:= GetSystemMetrics(SM_CXICON);
   SetIListProp(clWindow);
   for i:= 0 to Value.Count - 1 do IList.AddIcon(Value.Objects[i]);
end;

procedure THIListBoxEx.SetIndex;
var i:integer;
begin
   for i:= 0 to min((Value.Count - 1),(Control.Count - 1)) do Control.ItemData[i]:= integer(Value.Objects[i]);
end;

procedure THIListBoxEx._OnResize;
begin
   inherited;
   InitBackgroundImg;
end;

function THIListBoxEx._OnMeasureItem;
begin
   Result:= max(ImageSize, PControl(Sender).Canvas.TextExtent('W').cy);
end;

//---------------------       -----------------------

function THIListBoxEx._OnDrawItem;
const   SHIFT_PICTURE = 6;
        SHIFT_GUTTER = SHIFT_PICTURE div 2;

var     fControl: PControl;
        ARect,BRect,cbRect,gtRect: TRect;
        _Flags: dword;
        j,fIdx:integer;
        hdcMem: HDC;
        dx,dy:integer; 
begin
   Result:= False;
   fControl:= PControl(Sender);

   with fControl{$ifndef F_P}^{$endif} do begin
      if (Rect.Bottom - Rect.Top > Height) then exit;
      gtRect:= Rect;
      gtRect.Left:= gtRect.Left + SHIFT_GUTTER;
      gtRect.Right:= gtRect.Left + fImgSize + SHIFT_PICTURE;
      if not fTransparent then begin 
         dx:= Rect.Right - Rect.Left;
         dy:= Rect.Bottom - Rect.Top;
         j:= Height div dy;
         fIdx:= ItemIdx - (ItemIdx div j)*j; 
         if (fScaleImage <> GRADIENT) and (fBackgroundImg <> 0) then begin
            hdcMem:= CreateCompatibleDC(0);
            SelectObject(hdcMem, BackgroundImg);
            BitBlt(DC, 0, Rect.Top, dx, dy, hdcMem, 0, dy*fIdx, SRCCOPY);
            DeleteDC(hdcMem);
         end
         else if fScaleImage = GRADIENT then
            _Gradient(fControl,DC,Rect,true,fDepthBack,fLightClrBack,
                      fDarkClrBack,0,false,true,fInversBack);         
         if fGutter then begin
            _Gradient(fControl,DC,gtRect,true,fDepthGutter,fLightClrGutt,
                      fDarkClrGutt,0,false,true,fInversGutt);
         end;
         if (Itemidx = Count - 1) then begin
            cbRect:= Rect;
            cbRect.Top:= cbRect.Bottom;
            cbRect.Bottom:= Height;            
            if (fScaleImage <> GRADIENT) and (fBackgroundImg <> 0) then begin
               hdcMem:= CreateCompatibleDC(0);
               SelectObject(hdcMem, BackgroundImg);
               BitBlt(DC, 0, Rect.Bottom, dx, Height - Rect.Bottom, hdcMem, 0, dy*(fIdx+1), SRCCOPY);
               DeleteDC(hdcMem);               
            end
            else if fScaleImage = GRADIENT then begin
               _Gradient(fControl,DC,cbRect,true,fDepthBack,fLightClrBack,
                         fDarkClrBack,0,false,true,fInversBack); 
            end;
            if fGutter then begin
               gtRect.Top:= gtRect.Bottom;
               gtRect.Bottom:= Height;
               _Gradient(fControl,DC,gtRect,true,fDepthGutter,fLightClrGutt,
                         fDarkClrGutt,0,false,true,fInversGutt);
            end;
         end;   
      end;

      cbRect:= Rect;
      gtRect:= Rect;
      gtRect.Left:= gtRect.Left + SHIFT_GUTTER;
      gtRect.Right:= gtRect.Left + fImgSize + SHIFT_PICTURE;
      
      if (odsSelected in ItemState) then
         _Gradient(fControl,DC,cbRect,fGradient,fDepthGradient,fLightColor,fDarkColor,
                   fColorFrame,fFrame,fHorizontal,fInversGrad)
      else begin
         if not fTransparent and (((fBackgroundImg = 0) and (fScaleImage <> GRADIENT)) or (fScaleImage = NONE)) then begin
            Canvas.Brush.Color:= Color;
            FillRect(DC,cbRect,Canvas.Brush.Handle);
         end;
         if fGutter then
            _Gradient(fControl,DC,gtRect,true,fDepthGutter,fLightClrGutt,
                      fDarkClrGutt,0,false,true,fInversGutt);
      end;

      ARect:= Rect;
      ARect.Left:= ARect.Left + fImgSize + Canvas.TextExtent('W').cx + SHIFT_GUTTER;;
      BRect:= ARect; 
      inc(BRect.Left); inc(BRect.Top); inc(BRect.Right); inc(BRect.Bottom);
      SetTextColor(DC,Color2RGB(Font.Color));
      SetBkMode(DC, Font.Color);

      if fCutText then
         _Flags:=  DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX or DT_WORD_ELLIPSIS
      else
         _Flags:=  DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX;  

      if fBumpText then begin
         if (odsSelected in ItemState) and fGradient then begin
            if fInversClrTxt then
               SetTextColor(DC,Color2RGB(clBackground))
            else
               SetTextColor(DC,Color2RGB(clHighlightText));
            DrawText(DC, PChar(Items[ItemIdx]), -1, BRect, _Flags);
            if fInversClrTxt then
               SetTextColor(DC,Color2RGB(clHighlightText))
            else
               SetTextColor(DC,Color2RGB(Font.Color))
         end
         else if not (odsSelected in ItemState) and (fScaleImage = GRADIENT) then begin
            SetTextColor(DC,Color2RGB(clBackground));
            DrawText(DC, PChar(Items[ItemIdx]), -1, BRect, _Flags);
            SetTextColor(DC,Color2RGB(clHighlightText));
         end
         else
            SetTextColor(DC,Color2RGB(Font.Color));
      end
      else
         if (odsSelected in ItemState) then begin
            if fInversClrTxt then
               SetTextColor(DC,Color2RGB(clHighlightText))
            else
               SetTextColor(DC,Color2RGB(Font.Color));
         end
         else
            SetTextColor(DC,Color2RGB(Font.Color));

      DrawText(DC, PChar(Items[ItemIdx]), -1, ARect, _Flags);
      Result:= True;

      if not Assigned(IList) then exit;

      with cbRect do begin
         Top:= Top + (Bottom - Top - fImgSize) div 2;
         Left:= SHIFT_PICTURE;
         Bottom:= Top + fImgSize; 
         Right:= Left + fImgSize;
      end;
      IList.DrawingStyle:= [dsTransparent];      
      IList.StretchDraw(ItemData[ItemIdx],DC,cbRect);
   end;
end;

procedure THIListBoxEx._work_doSelectAll;
var a:boolean; i:integer;
begin
  a := ReadBool(_Data);
  if fMultiSelect then
    Control.ItemSelected[-1] := a
  else for i := 0 to Control.Count-1 do
    Control.ItemSelected[i] := a;
end;

procedure THIListBoxEx.Select;
begin
  if  fMultiSelect then
    Control.ItemSelected[idx] := not Control.ItemSelected[idx]
  else inherited;
end;

procedure THIListBoxEx._work_doEnsureVisible;
begin
  Control.Perform(LB_SETTOPINDEX, ToInteger(_Data), 0);
end;

procedure THIListBoxEx._var_Index;
begin
  dtInteger(_Data,Control.CurIndex);
end;

procedure THIListBoxEx._arr_set;
var ind:integer;
begin
  ind := ToIntIndex(Item);
  if(ind >=0)and(ind < Control.Count)then
    Control.ItemSelected[ind] := ReadBool(Val);
end;

function THIListBoxEx._arr_get;
var ind:integer;
begin
  ind := ToIntIndex(Item);
  Result := (ind >=0 )and(ind < Control.Count);
  if Result then
     dtInteger(Val,byte(Control.ItemSelected[ind]));
end;

function THIListBoxEx._arr_count;
var i:smallint;
begin
  Result := 0;
  for i := 0 to Control.Count-1 do
    if Control.ItemSelected[i] then
      inc(Result);
end;

procedure THIListBoxEx._val_arr_set;
var ind:integer;
begin
  ind := ToIntIndex(Item);
  if(ind >=0 )and(ind < Control.Count)then
    Control.ItemData[ind] := ToInteger(Val);
end;

function THIListBoxEx._val_arr_get;
var ind:integer;
begin
  ind := ToIntIndex(Item);
  Result := (ind >=0 )and(ind < Control.Count);
  if Result then
    dtInteger(Val,Control.ItemData[ind]);
end;

function THIListBoxEx._val_arr_count;
begin
  Result := Control.Count;
end;

procedure THIListBoxEx._var_SelectArray;
begin
  if Arr = nil then
    Arr := CreateArray(_arr_set,_arr_get,_arr_count,nil);
  dtArray(_Data,Arr);
end;

procedure THIListBoxEx._var_ValueArray;
begin
  if ValArr = nil then
    ValArr := CreateArray(_val_arr_set,_val_arr_get,_val_arr_count,nil);
  dtArray(_Data,ValArr);
end;

//-------------------         ---------------------

procedure THIListBoxEx._var_IconArray;
begin
  if Assigned(Ilist) then
     begin
        if not Assigned(ICArray) then ICArray := CreateArray(_SetIcon,_GetIcon,_CountIcon,_AddIcon);
        dtArray(_Data,ICArray);
     end
  else dtArray(_Data,nil);
end;

procedure THIListBoxEx._SetIcon;
var   ind:integer;
begin
   if not Assigned(Ilist) then Exit;
   SetIListProp(clWindow);
   ind:= ToIntIndex(Item);
   if (ind >= 0)and(ind < IList.Count) and _IsIcon(Val) then
      IList.ReplaceIcon(ind, ToIcon(val).handle);
   Control.Invalidate;
end;

function THIListBoxEx._GetIcon;
var   ind:integer;
begin
   Result:= False;
   if not Assigned(Ilist) then Exit;
   SetIListProp(clWindow);
   ind:= ToIntIndex(Item);
   if (ind >= 0)and(ind < IList.Count) then begin
      if Assigned(Icon) then Icon.free;
      Icon:= NewIcon;
      Icon.Handle:= IList.ExtractIcon(ind);
      if not fIconToBmp then
         dtIcon(Val,Icon)
      else begin
         if Assigned(bmp) then bmp.free;
         bmp:= NewDIBBitmap(Icon.Size,Icon.Size,pf32bit);
         bmp.Handle:= Icon.Convert2Bitmap(fBmpTransparent);
         dtBitmap(Val,bmp);
      end;
      Result:= True;
   end;
end;

function THIListBoxEx._CountIcon;
begin
   Result:=0;
   if not Assigned(Ilist) then Exit;
   Result:= IList.Count;
end;

procedure THIListBoxEx._AddIcon;
begin
   if not Assigned(Ilist) then Exit;
   SetIListProp(clWindow);
   if _IsIcon(Val) then IList.AddIcon(ToIcon(Val).Handle);
   Control.Invalidate;
end;

end.
